<script lang="ts">
	import { createBubbler } from 'svelte/legacy';

	const bubble = createBubbler();
	interface Props {
		style: string | undefined;
		routeName?: string;
		routeDistanceKM?: number;
		timeGoal?: number;
		timeStarted?: number;
		routeProgressKM?: number;
	}

	let {
		style,
		routeName = 'Route Name',
		routeDistanceKM = 420,
		timeGoal = 0,
		timeStarted = 0,
		routeProgressKM = 0
	}: Props = $props();

	let timeSpan = $derived(timeGoal - timeStarted)
	let timeElapsed = $derived(Date.now() - timeStarted)
	let timeLeft = $derived(timeGoal - Date.now())

	let kmProgress = $derived(Math.round((routeProgressKM / routeDistanceKM) * 100))
	let timeProgress = $derived(Math.round((timeElapsed / timeSpan) * 100))

</script>

<div id="meta" {style} onclick={bubble('click')} onkeyup={bubble('keyup')}>
	<h2>{routeName} ({routeDistanceKM} km)</h2>

	<div class="distance" style="--progress: {kmProgress}%">
		<h4>{routeProgressKM} km</h4>
		<!-- <h4>{progress}</h4> -->
	</div>
	<div style="grid-area: gap; background-color: #FFFFFF33"></div>
	<div class="time" style="--progress: {100 - timeProgress}%">
		<h4>{Math.round(timeLeft / (1000 * 60 * 60 * 24))} days</h4>
		<!-- <h4>{progress}</h4> -->
	</div>
</div>

<style>
	#meta {
		display: grid;
		grid-template-columns: 1fr 2px 1fr;
		grid-template-rows: 75% 25%;
		grid-template-areas:
			'name name name'
			'distance gap time';
		height: 100%;
	}

	h2 {
		font-size: 1.8rem;
		color: var(--accentColour);
		margin: auto 1rem auto 1rem;
		text-align: left;
		grid-area: name;
		text-align: center;
		background-color: transparent;
	}

	@media(max-width: 412px) {
		h2 {
			font-size: 7vw;
		}
	}

	@media(max-width: 300px) {
		h2 {
			font-size: 10vw
		}
	}

	h4 {
		font-size: 1.2rem;
		font-weight: 500;
		margin-top: auto;
		margin-bottom: auto;
		color: white;
		margin-right: 5px;
		text-align: right;
	}
	.distance {
		grid-area: distance;
		/* width: var(--progress); */
		/* width: 50%; */
		background-color: var(--accentColour);
		display: flex;
		justify-content: flex-end;
		flex-direction: column;
		background: linear-gradient(90deg, var(--accentColour) 0 var(--progress), #222 var(--progress) 100%);
	}

	.distance h4 {
		text-align: left;
		margin-left: 5px;
	}

	.time h4 {
		text-align: right;
		margin-right: 5px;
	}

	.time {
		grid-area: time;
		/* width: var(--progress); */
		/* width: 50%; */
		background-color: var(--accentColour);
		display: flex;
		justify-content: flex-start;
		flex-direction: column;
		background: linear-gradient(90deg, #222 0 var(--progress), var(--accentColour) var(--progress) 100%);
	}
</style>
